Unit AFG5C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, UTAFSI_p;

procedure AFG5C(var A :Array of Complex; M :Integer; N :Integer;
                var NLEAD :Array of Integer; var IERR :Integer);

implementation

procedure AFG5C(var A :Array of Complex; M :Integer; N :Integer;
                var NLEAD :Array of Integer; var IERR :Integer);
var
I,J,JJ,K,KP1,L,NM1 :Integer;
R,X :Real;
T :Complex;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200;
{  -  FORTRAN }
function C1ABS(T: Complex): Real;
begin
Result := Abs(Creal(T)) + Abs(Aimag(T));
end;
{   - }
begin
{ ********************************************************************C }
{   LU-PAOEHE MATP A METOOM AYCCA C BOPOM                  C }
{   BEYEO EMEHTA O CTOY                                      C }
{                                                                     C }
{   M-CO CTPOK MATP(T:INTEGER)                                C }
{   N-PAMEP MATP(T:INTEGER)                                     C }
{   A-MATPA M*N,HA BXOE COEPT CXOHY MATPY,                 C }
{   HA BXOE HA COOTBETCTBYX MECTAX HAXOTC EMEHT            C }
{   MATP U  OAOHAHE EMEHT                              C }
{   MAPT INVERSE(L)(T:COMPLEX)                                   C }
{   NLEAD-BEKTOP H N,HA BXOE COEPT BEKTOP,OPOA        C }
{   MATPY EPECTAHOBOK(T:INTEGER)                                 C }
{   IERR-EPEMEHHA,YKABAA PHY BXOA(T:INTEGER)           C }
{                                                                     C }
{ ********************************************************************C }

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
X := 0.0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( N >=  1 ) and (  M >=  1 ) 
 then goto _20;
IERR := 65;
UTAFSI('A','F','G','5','C',IERR);
goto _200;
_20:
IERR := 0;
NM1 := N - 1;
if ( NM1 <  1 ) 
 then goto _190;
for K:=1 to NM1 do
 begin
  KP1 := K + 1;

{   HAXOEHE HEKCA BEYEO EMEHTA L }
  L := K;
  R := C1ABS(A[(K-1)+(K-1)*M]);
  for J:=KP1 to N do
   begin
    if ( C1ABS(A[(J-1)+(K-1)*M]) <=  R ) 
     then goto _30;
    L := J;
    R := C1ABS(A[(J-1)+(K-1)*M]);
_30:
_40:
   end;
  NLEAD[K-1] := L;
  if ( Cabs(A[(L-1)+(K-1)*M]) =  0.0 ) 
   then goto _160;

{   EPECTAHOBKA,EC TPEYETC }
  if ( L =  K ) 
   then goto _50;
  T := A[(L-1)+(K-1)*M];
  A[(L-1)+(K-1)*M] := A[(K-1)+(K-1)*M];
  A[(K-1)+(K-1)*M] := T;
_50:

{   BCEHE MHOTEE }
  T := DivC(Cmplx(-1.0,0.0),A[(K-1)+(K-1)*M]);
  J := N - K;
  I := ((J) Mod (5)) + K;
  if ( I =  K ) 
   then goto _70;
  for J:=KP1 to I do
   begin
    A[(J-1)+(K-1)*M] := MulC(T,A[(J-1)+(K-1)*M]);
_60:
   end;
_70:
  I := I + 1;
  if ( I >  N ) 
   then goto _90;
  J := I;
  while ( J<=N ) do
   begin
    A[(J-1)+(K-1)*M] := MulC(T,A[(J-1)+(K-1)*M]);
    A[(J+0)+(K-1)*M] := MulC(T,A[(J+0)+(K-1)*M]);
    A[(J+1)+(K-1)*M] := MulC(T,A[(J+1)+(K-1)*M]);
    A[(J+2)+(K-1)*M] := MulC(T,A[(J+2)+(K-1)*M]);
    A[(J+3)+(K-1)*M] := MulC(T,A[(J+3)+(K-1)*M]);
_80:
    inc(J,5);
   end;
_90:

{   AYCCOBO CKEHE }
  for J:=KP1 to N do
   begin
    T := A[(L-1)+(J-1)*M];
    if ( L =  K ) 
     then goto _100;
    A[(L-1)+(J-1)*M] := A[(K-1)+(J-1)*M];
    A[(K-1)+(J-1)*M] := T;
_100:
    JJ := N - K;
    I := ((JJ) Mod (4)) + K;
    if ( I =  K ) 
     then goto _120;
    for JJ:=KP1 to I do
     begin
      A[(JJ-1)+(J-1)*M] := AddC(A[(JJ-1)+(J-1)*M],MulC(T,A[(JJ-1)+(K-1)*M]));
_110:
     end;
_120:
    I := I + 1;
    if ( I >  N ) 
     then goto _140;
    JJ := I;
    while ( JJ<=N ) do
     begin
      A[(JJ-1)+(J-1)*M] := AddC(A[(JJ-1)+(J-1)*M],MulC(T,A[(JJ-1)+(K-1)*M]));
      A[(JJ+0)+(J-1)*M] := AddC(A[(JJ+0)+(J-1)*M],MulC(T,A[(JJ+0)+(K-1)*M]));
      A[(JJ+1)+(J-1)*M] := AddC(A[(JJ+1)+(J-1)*M],MulC(T,A[(JJ+1)+(K-1)*M]));
      A[(JJ+2)+(J-1)*M] := AddC(A[(JJ+2)+(J-1)*M],MulC(T,A[(JJ+2)+(K-1)*M]));
_130:
      inc(JJ,4);
     end;
_140:
_150:
   end;
  goto _170;
_160:
  IERR := -K;
_170:
_180:
 end;
_190:
NLEAD[N-1] := N;
if ( Cabs(A[(N-1)+(N-1)*M]) =  0.0 ) 
 then IERR := -N;
if ( IERR =  0 ) 
 then goto _200;
UTAFSI('A','F','G','5','C',IERR);
_200:
end;

end.
