Unit AMMGC_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AFG5C_p, UTAFSI_p;

procedure AMMGC(var A :Array of Complex; M :Integer;
                N :Integer; var NLEAD :Array of Integer;
                var B :Array of Complex; MM :Integer; NN :Integer;
                var IERR :Integer);

implementation

procedure AMMGC(var A :Array of Complex; M :Integer;
                N :Integer; var NLEAD :Array of Integer;
                var B :Array of Complex; MM :Integer; NN :Integer;
                var IERR :Integer);
var
I,J,JI,JJ,K,KB,KP1,NM1 :Integer;
S :Real;
T :Complex;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220;
begin
{ ***************************************************C }
{   YMHOEHE MATP,OPATHO K AAHHO KBAPAT-   C }
{   HO MATPE A,HA PMOYOHY MATPY B.        C }
{ ***************************************************C }

{   YCTAHOBEHE KOHTPO HA BOMOHOCT EPEOHEH }
S  := 0.0;
_10:

{   POBEPKA PABHOCT AAH APAMETPOB M  N }
if ( N  >=  1 ) and (  M  >=  1 ) 
 then goto _30;
_20:
IERR  := 65;
UTAFSI('A','M','M','G','C',IERR);
goto _220;
_30:
if ( NN  >=  1 ) and (  MM  >=  1 ) 
 then goto _40;
goto _20;
_40:
IERR  := 0;
AFG5C(A,M,N,NLEAD,IERR);
if ( IERR  <>  0 ) 
 then UTAFSI('A','M','M','G','C',IERR);
if ( IERR  <=  0 ) 
 then goto _50;
goto _220;
_50:
NM1  := N - 1;
for JI:=1 to NN do
 begin

{   PEEHE CCTEM L*Y=B(JI) }
  if ( NM1  <  1 ) 
   then goto _120;
  for K:=1 to NM1 do
   begin
    JJ  := NLEAD[K-1];
    T  := B[(JJ-1)+(JI-1)*MM];
    if ( JJ  =  K ) 
     then goto _60;
    B[(JJ-1)+(JI-1)*MM] := B[(K-1)+(JI-1)*MM];
    B[(K-1)+(JI-1)*MM] := T;
_60:
    JJ  := N - K;
    I  := ((JJ) Mod (4)) + K;
    if ( I  =  K ) 
     then goto _80;
    KP1  := K + 1;
    for JJ:=KP1 to I do
     begin
      B[(JJ-1)+(JI-1)*MM] := AddC(B[(JJ-1)+(JI-1)*MM],MulC(T,A[(JJ-1)+(K-1)*M]));
_70:
     end;
_80:
    I  := I + 1;
    if ( I  >  N ) 
     then goto _100;
    JJ := I;
    while ( JJ<=N ) do
     begin
      B[(JJ-1)+(JI-1)*MM] := AddC(B[(JJ-1)+(JI-1)*MM],MulC(T,A[(JJ-1)+(K-1)*M]));
      B[(JJ+0)+(JI-1)*MM] := AddC(B[(JJ+0)+(JI-1)*MM],MulC(T,A[(JJ+0)+(K-1)*M]));
      B[(JJ+1)+(JI-1)*MM] := AddC(B[(JJ+1)+(JI-1)*MM],MulC(T,A[(JJ+1)+(K-1)*M]));
      B[(JJ+2)+(JI-1)*MM] := AddC(B[(JJ+2)+(JI-1)*MM],MulC(T,A[(JJ+2)+(K-1)*M]));
_90:
      inc(JJ,4);
     end;
_100:
_110:
   end;
_120:

{   PEEHE CCTEM U*X=Y }
  for KB:=1 to N do
   begin
    K  := N + 1 - KB;
    if ( Cabs(A[(K-1)+(K-1)*M]) <>  0.0 ) 
     then goto _140;
    if ( Cabs(B[(K-1)+(JI-1)*MM]) <>  0.0 ) 
     then goto _130;
    B[(K-1)+(JI-1)*MM] := Cmplx(1.0,0.0);
    goto _150;
_130:
    IERR  := 67;
    UTAFSI('A','M','M','G','C',IERR);
    goto _220;
_140:
    B[(K-1)+(JI-1)*MM] := DivC(B[(K-1)+(JI-1)*MM],A[(K-1)+(K-1)*M]);
_150:
    T  := B[(K-1)+(JI-1)*MM];
    J  := K - 1;
    I  := ((J) Mod (4));
    if ( I  =  0 ) 
     then goto _170;
    for JJ:=1 to I do
     begin
      B[(JJ-1)+(JI-1)*MM] := SubC(B[(JJ-1)+(JI-1)*MM],MulC(T,A[(JJ-1)+(K-1)*M]));
_160:
     end;
_170:
    I  := I + 1;
    if ( I  >  J ) 
     then goto _190;
    JJ := I;
    while ( JJ<=J ) do
     begin
      B[(JJ-1)+(JI-1)*MM] := SubC(B[(JJ-1)+(JI-1)*MM],MulC(T,A[(JJ-1)+(K-1)*M]));
      B[(JJ+0)+(JI-1)*MM] := SubC(B[(JJ+0)+(JI-1)*MM],MulC(T,A[(JJ+0)+(K-1)*M]));
      B[(JJ+1)+(JI-1)*MM] := SubC(B[(JJ+1)+(JI-1)*MM],MulC(T,A[(JJ+1)+(K-1)*M]));
      B[(JJ+2)+(JI-1)*MM] := SubC(B[(JJ+2)+(JI-1)*MM],MulC(T,A[(JJ+2)+(K-1)*M]));
_180:
      inc(JJ,4);
     end;
_190:
_200:
   end;
_210:
 end;
_220:
end;

end.
